Imports System.IO
Imports System.Text
Imports System.XML
Imports System.Security.Principal
Imports System.Threading
Imports System.Collections.Specialized
Imports System.Runtime.InteropServices
Imports System.ComponentModel

' A collection of Shared functions that are used by the Snoop class.
' Note: there is no error checking done here... all errors "bubbled up"
' to the calling routine (with one exception in the ErrorLog method)

Public Class Misc

#Region "API Region"
    Private Enum AccessType As Integer
        DELETE = &H10000
        READ_CONTROL = &H20000
        WRITE_DAC = &H40000
        WRITE_OWNER = &H80000
        SYNCHRONIZE = &H100000
        STANDARD_RIGHTS_REQUIRED = &HF0000
        STANDARD_RIGHTS_READ = READ_CONTROL
        STANDARD_RIGHTS_WRITE = READ_CONTROL
        STANDARD_RIGHTS_EXECUTE = READ_CONTROL
        STANDARD_RIGHTS_ALL = &H1F0000
        SPECIFIC_RIGHTS_ALL = &HFFFF
        ACCESS_SYSTEM_SECURITY = &H1000000
        MAXIMUM_ALLOWED = &H2000000
        GENERIC_READ = &H80000000
        GENERIC_WRITE = &H40000000
        GENERIC_EXECUTE = &H20000000
        GENERIC_ALL = &H10000000
        FILE_LIST_DIRECTORY = &H1
        FILE_ADD_FILE = &H2
        FILE_ADD_SUBDIRECTORY = &H4
        FILE_READ_EA = &H8
        FILE_WRITE_EA = &H10
        FILE_TRAVERSE = &H20
        FILE_DELETE_CHILD = &H40
        FILE_READ_ATTRIBUTES = &H80
        FILE_WRITE_ATTRIBUTES = &H100
        FILE_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &H1FF
        FILE_GENERIC_READ = STANDARD_RIGHTS_READ Or FILE_LIST_DIRECTORY Or FILE_READ_ATTRIBUTES Or FILE_READ_EA Or SYNCHRONIZE
        FILE_GENERIC_WRITE = STANDARD_RIGHTS_WRITE Or FILE_ADD_FILE Or FILE_WRITE_ATTRIBUTES Or FILE_WRITE_EA Or FILE_ADD_SUBDIRECTORY Or SYNCHRONIZE
        FILE_GENERIC_EXECUTE = STANDARD_RIGHTS_EXECUTE Or FILE_READ_ATTRIBUTES Or FILE_TRAVERSE Or SYNCHRONIZE
    End Enum

    'BOOL LookupAccountName(
    '  LPCTSTR lpSystemName,
    '  LPCTSTR lpAccountName,
    '  PSID Sid,
    '  LPDWORD cbSid,
    '  LPTSTR ReferencedDomainName,
    '  LPDWORD cchReferencedDomainName,
    '  PSID_NAME_USE peUse
    ');
    Private Declare Auto Function LookupAccountName Lib "advapi32.dll" ( _
        ByVal lpSystemName As String, _
        ByVal lpAccountName As String, _
        ByVal Sid As IntPtr, _
        ByRef cbSid As Integer, _
        ByVal lpReferenceDomainName As String, _
        ByRef cchReferencedDomainName As Integer, _
        ByRef peUse As Integer _
    ) As Boolean

    'BOOL ConvertSidToStringSid(
    '  PSID Sid,
    '  LPTSTR* StringSid
    ');
    Private Declare Auto Function ConvertSidToStringSid Lib "advapi32.dll" ( _
        ByVal Sid As IntPtr, _
        ByRef StringSid As IntPtr _
    ) As Boolean

    'int GetSystemMetrics(
    '  int nIndex
    ');
    Private Declare Function GetSystemMetrics Lib "User32" ( _
        ByVal nIndex As Integer _
    ) As Integer

    'BOOL LookupAccountSid(
    '  LPCTSTR lpSystemName,
    '  PSID lpSid,
    '  LPTSTR lpName,
    '  LPDWORD cchName,
    '  LPTSTR lpReferencedDomainName,
    '  LPDWORD cchReferencedDomainName,
    '  PSID_NAME_USE peUse
    ');
    Private Declare Auto Function LookupAccountSid Lib "advapi32.dll" ( _
        ByVal lpSystemName As String, _
        ByVal lpSid As IntPtr, _
        ByVal lpName As String, _
        ByRef cchName As Integer, _
        ByVal lpReferenceDomainName As String, _
        ByRef cchReferencedDomainName As Integer, _
        ByRef peUse As Integer _
    ) As Boolean

    'BOOL ConvertStringSidToSid(
    '  LPCTSTR StringSid,
    '  PSID* Sid
    ');
    Private Declare Auto Function ConvertStringSidToSid Lib "advapi32.dll" ( _
        ByVal StringSid As String, _
        ByRef Sid As IntPtr _
    ) As Boolean


    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Private Structure LUID_AND_ATTRIBUTES
        Dim Luid As Long
        Dim Attributes As Integer
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Private Structure TOKEN_PRIVILEGES
        Dim PrivilegeCount As Integer
        Dim Privilege1 As LUID_AND_ATTRIBUTES
        Dim Privilege2 As LUID_AND_ATTRIBUTES
        Dim Privilege3 As LUID_AND_ATTRIBUTES
    End Structure

    'BOOL OpenProcessToken(
    '  HANDLE ProcessHandle,
    '  DWORD DesiredAccess,
    '  PHANDLE TokenHandle
    ');
    Private Declare Function OpenProcessToken Lib "advapi32.dll" ( _
        ByVal ProcessHandle As IntPtr, _
        ByVal DesiredAccess As Integer, _
        ByRef TokenHandle As IntPtr _
    ) As Boolean

    'BOOL LookupPrivilegeValue(
    '  LPCTSTR lpSystemName,
    '  LPCTSTR lpName,
    '  PLUID lpLuid
    ');
    Private Declare Auto Function LookupPrivilegeValue Lib "advapi32.dll" ( _
        ByVal lpSystemName As String, _
        ByVal lpName As String, _
        ByRef lpLuid As Long _
    ) As Boolean

    'BOOL AdjustTokenPrivileges(
    '  HANDLE TokenHandle,
    '  BOOL DisableAllPrivileges,
    '  PTOKEN_PRIVILEGES NewState,
    '  DWORD BufferLength,
    '  PTOKEN_PRIVILEGES PreviousState,
    '  PDWORD ReturnLength
    ');
    Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" ( _
        ByVal TokenHandle As IntPtr, _
        ByVal DisableAllPrivileges As Boolean, _
        ByRef NewState As TOKEN_PRIVILEGES, _
        ByVal BufferLength As Integer, _
        ByVal PreviousState As IntPtr, _
        ByRef ReturnLength As Integer _
    ) As Boolean

    'typedef enum _SE_OBJECT_TYPE {
    '  SE_UNKNOWN_OBJECT_TYPE = 0,
    '  SE_FILE_OBJECT,
    '  SE_SERVICE,
    '  SE_PRINTER,
    '  SE_REGISTRY_KEY,
    '  SE_LMSHARE,
    '  SE_KERNEL_OBJECT,
    '  SE_WINDOW_OBJECT,
    '  SE_DS_OBJECT,
    '  SE_DS_OBJECT_ALL,
    '  SE_PROVIDER_DEFINED_OBJECT,
    '  SE_WMIGUID_OBJECT,
    '  SE_REGISTRY_WOW64_32
    '} SE_OBJECT_TYPE;
    Private Enum SE_OBJECT_TYPE As Integer
        SE_UNKNOWN_OBJECT_TYPE = 0
        SE_FILE_OBJECT
        SE_SERVICE
        SE_PRINTER
        SE_REGISTRY_KEY
        SE_LMSHARE
        SE_KERNEL_OBJECT
        SE_WINDOW_OBJECT
        SE_DS_OBJECT
        SE_DS_OBJECT_ALL
        SE_PROVIDER_DEFINED_OBJECT
        SE_WMIGUID_OBJECT
        SE_REGISTRY_WOW64_32
    End Enum

    Private Enum SECURITY_INFORMATION As Integer
        OWNER_SECURITY_INFORMATION = 1
        GROUP_SECURITY_INFORMATION = 2
        DACL_SECURITY_INFORMATION = 4
        SACL_SECURITY_INFORMATION = 8
        PROTECTED_SACL_SECURITY_INFORMATION = 16
        PROTECTED_DACL_SECURITY_INFORMATION = 32
        UNPROTECTED_SACL_SECURITY_INFORMATION = 64
        UNPROTECTED_DACL_SECURITY_INFORMATION = 128
    End Enum

    Private Const TOKEN_QUERY As Integer = &H8
    Private Const TOKEN_ADJUST_PRIVILEGES As Integer = &H20
    Private Const SE_RESTORE_NAME As String = "SeRestorePrivilege"
    Private Const SE_BACKUP_NAME As String = "SeBackupPrivilege"
    Private Const SE_SECURITY_NAME As String = "SeSecurityPrivilege"
    Private Const SE_PRIVILEGE_ENABLED As Integer = &H2
    Private Const HKEY_USERS As Integer = &H80000003
    Private Const NAME_SIZE As Integer = 64
    Private Const SM_REMOTESESSION As Integer = &H1000

    'typedef struct _SID_IDENTIFIER_AUTHORITY {
    '  BYTE Value[6];
    '} SID_IDENTIFIER_AUTHORITY, *PSID_IDENTIFIER_AUTHORITY;
    Private Structure SID_IDENTIFIER_AUTHORITY
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> Dim Value() As Byte
    End Structure

    'BOOL IsValidSid(
    '  PSID pSid
    ');
    Private Declare Function IsValidSid Lib "advapi32.dll" ( _
        ByVal pSid As IntPtr _
    ) As Boolean

    'PSID_IDENTIFIER_AUTHORITY GetSidIdentifierAuthority(
    '  PSID pSid
    ');
    Private Declare Function GetSidIdentifierAuthority Lib "advapi32.dll" ( _
        ByVal pSid As IntPtr _
    ) As IntPtr

    'PUCHAR GetSidSubAuthorityCount(
    '  PSID pSid
    ');
    Private Declare Function GetSidSubAuthorityCount Lib "advapi32.dll" ( _
        ByVal pSid As IntPtr _
    ) As IntPtr

    'PDWORD GetSidSubAuthority(
    '  PSID pSid,
    '  DWORD nSubAuthority
    ');
    Private Declare Function GetSidSubAuthority Lib "advapi32.dll" ( _
        ByVal pSid As IntPtr, _
        ByVal nSubAuthority As Integer _
    ) As IntPtr

    'BOOL AllocateAndInitializeSid(
    '  PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority,
    '  BYTE nSubAuthorityCount,
    '  DWORD dwSubAuthority0,
    '  DWORD dwSubAuthority1,
    '  DWORD dwSubAuthority2,
    '  DWORD dwSubAuthority3,
    '  DWORD dwSubAuthority4,
    '  DWORD dwSubAuthority5,
    '  DWORD dwSubAuthority6,
    '  DWORD dwSubAuthority7,
    '  PSID* pSid
    ');
    Private Declare Function AllocateAndInitializeSid Lib "advapi32.dll" ( _
        ByRef pIdentifierAuthority As SID_IDENTIFIER_AUTHORITY, _
        ByVal nSubAuthorityCount As Byte, _
        ByVal dwSubAuthority0 As Integer, _
        ByVal dwSubAuthority1 As Integer, _
        ByVal dwSubAuthority2 As Integer, _
        ByVal dwSubAuthority3 As Integer, _
        ByVal dwSubAuthority4 As Integer, _
        ByVal dwSubAuthority5 As Integer, _
        ByVal dwSubAuthority6 As Integer, _
        ByVal dwSubAuthority7 As Integer, _
        ByRef pSid As IntPtr _
    ) As Boolean

#End Region

    Public Enum ErrLogLevel As Integer
        None = 0
        Errors
        Full
    End Enum

    '
    ' Convert a Remote PC name, Local path name pair into a UNC style path
    '
    Public Shared Function ConvUNC(ByVal RemotePC As String, ByVal Path As String) As String
        Dim ans As String

        If RemotePC = "" Or String.Compare(RemotePC, Environment.MachineName, True) = 0 Then
            Return Path
        End If

        ans = ""
        If Path.Length > 2 Then
            ans = "\\" & RemotePC & "\" & Path.Substring(0, 1) & "$" & Path.Substring(2)
        End If
        Return ans
    End Function

    '
    ' Expand environmental variables based upon the remote PCs environment
    '
    Public Shared Function ExpandEnv(ByVal RemotePC As String, ByVal Value As String, ByVal SystemPathVars As StringDictionary) As String
        Dim ans, key, parts() As String

        If RemotePC = "" Or String.Compare(RemotePC, Environment.MachineName, True) = 0 Then
            ' expanding local variables is trivial
            Return Environment.ExpandEnvironmentVariables(Value)
        End If

        ans = Value

        ' find the environmental variable (we only support one!)
        parts = Value.Split("%"c)
        If parts.Length > 1 Then
            key = parts(1)
            If SystemPathVars.ContainsKey(key.ToLower) Then
                ans = Value.Replace("%" & key & "%", SystemPathVars(key.ToLower))
            Else
                ' record the missing Environmental Variable
                Dim ex As New ArgumentException("Environmental Variable '" & key & "' not found")
                ErrorLog(ex, RemotePC, "ExpandEnv", Misc.ErrLogLevel.Full)
            End If
        End If

        Return ans
    End Function

    '
    ' Get the name of the remotely logged in user
    '
    Public Shared Function GetRemoteUser(ByVal RemotePC As String, ByVal reg As RegistryKey) As String
        Dim key, subkey As RegistryKey
        Dim user, keyname, CurKey, UserName, DomainName As String
        Dim name_len, domain_len, peUse As Integer
        Dim got_it As Boolean
        Dim Sid As IntPtr

        CurKey = ""
        user = ""
        Try
            ' Find the User key that has "Volatile Environment"... that's
            ' either the current user or the last user logged in.
            got_it = False
            For Each keyname In reg.GetSubKeyNames()
                key = reg.OpenSubKey(keyname, False)
                If Not IsNothing(key) Then
                    If Array.IndexOf(key.GetSubKeyNames(), "Volatile Environment") >= 0 Then
                        CurKey = keyname
                        ' for WinXP's alternate login, we must check to
                        ' see if the CLIENTNAME is "Console"
                        subkey = key.OpenSubKey("Volatile Environment")
                        If Not IsNothing(subkey) Then
                            If subkey.GetValue("CLIENTNAME", "").ToString = "Console" Then
                                got_it = True
                            End If
                            subkey.Close()
                        End If
                    End If
                    key.Close()
                    If got_it Then
                        Exit For
                    End If
                End If
            Next

            ' Nope, didn't find anything
            If CurKey = "" Then
                Return ""
            End If

            ' In rare cases, the user's registry hive is still loaded.  So
            ' to test if there is anybody currently logged on, we see if
            ' the remote PC has an explorer.exe process running
            If Process.GetProcessesByName("explorer", RemotePC).Length = 0 Then
                Return ""
            End If

            ' Now let's get the logon name from the string version of the
            ' Sid (which is the registry key name)
            Sid = StringToSID(CurKey)
            If IsNothing(Sid) Then
                Return ""
            End If

            name_len = NAME_SIZE
            domain_len = NAME_SIZE
            UserName = Space(name_len)
            DomainName = Space(domain_len)

            ' look up the Account associated with that SID
            If LookupAccountSid(RemotePC, Sid, UserName, name_len, DomainName, domain_len, peUse) = False Then
                Return ""
            End If
            If domain_len > 0 Then
                user = Left(DomainName, domain_len) & "\" & Left(UserName, name_len)
            Else
                user = RemotePC & "\" & Left(UserName, name_len)
            End If
        Catch ex As Exception
            Return ""
        End Try

        Return user
    End Function

    '
    ' Is this a Remote Desktop (aka Terminal Services) session?
    '
    Public Shared Function IsRemoteSession() As Boolean
        If GetSystemMetrics(SM_REMOTESESSION) <> 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    '
    ' Are you an administrator on this PC?
    '
    Public Shared Function IsAdmin() As Boolean
        Dim MyPrincipal As WindowsPrincipal

        AppDomain.CurrentDomain.SetPrincipalPolicy(PrincipalPolicy.WindowsPrincipal)
        MyPrincipal = CType(Thread.CurrentPrincipal, WindowsPrincipal)
        Try
            If MyPrincipal.IsInRole(WindowsBuiltInRole.Administrator) Then
                Return True
            Else
                Return False
            End If
        Catch
        End Try

        ' if the built-in role doesn't exist... then report false
        Return False
    End Function

    '
    ' Determine if the remote user is an administrator on that PC
    ' Note: Doesn't work for WinNT
    '
    Public Shared Function IsRemoteAdmin(ByVal MachineName As String, ByVal reg As RegistryKey, ByVal UID As String) As Boolean
        Dim key As RegistryKey
        Dim temp, parts(), SID, DomainBuf As String
        Dim Sid_ptr As IntPtr
        Dim ans As Boolean
        Dim lenDomain, lenSid, peUse As Integer

        ' Sanity check
        If IsNothing(UID) OrElse UID.Length = 0 Then
            Return False
        End If

        ' Parse the Domain and User name
        parts = UID.Split("\"c)
        If UBound(parts) <> 1 Then
            Return False
        End If

        ' do a "dry run" to get the size of the SID and Domain string
        LookupAccountName(MachineName, UID, IntPtr.Zero, lenSid, "", lenDomain, peUse)
        DomainBuf = Space(lenDomain)
        Sid_ptr = Marshal.AllocHGlobal(lenSid)

        ' do it again, for real this time
        If LookupAccountName(MachineName, UID, Sid_ptr, lenSid, DomainBuf, lenDomain, peUse) = False Then
            Marshal.FreeHGlobal(Sid_ptr)
            Return False
        End If

        ' convert the SID to a string
        SID = SIDtoString(Sid_ptr)
        Marshal.FreeHGlobal(Sid_ptr)

        If IsNothing(SID) OrElse SID = "" Then
            Return False
        End If

        ' The GroupMembership key contains a list of cached group SIDs that
        ' the user is a member of
        ans = False
        Try
            key = reg.OpenSubKey(SID & "\Software\Microsoft\Windows\CurrentVersion\Group Policy\GroupMembership")
            If Not IsNothing(key) Then
                For Each temp In key.GetValueNames
                    If temp.StartsWith("Group") Then
                        ' the Builtin Administrators group SID
                        If key.GetValue(temp, "").ToString = "S-1-5-32-544" Then
                            ans = True
                            Exit For
                        End If
                    End If
                Next
                key.Close()
            End If
        Catch ex As System.Security.SecurityException
            ' non-administrators can't open other user's mounted registry keys
            Return False
        End Try

        Return ans
    End Function

    '
    ' Write to a text-based error log (since some errors may be database
    ' related, this is the most reliable way).  This is similar in concept to
    ' the Microsoft Error Reporting Service, whereby the developers get a
    ' detailed report as to what went wrong.  The contents of this log are
    ' designed for the developer, not the user.
    '
    Public Shared Sub ErrorLog(ByVal ex As Exception, ByVal PC_Name As String, ByVal TableName As String, ByVal DetailLevel As ErrLogLevel)
        Dim asm As System.Reflection.Assembly
        Dim sb As New StringBuilder
        Dim logfile, loglevel As String
        Dim logging As ErrLogLevel

        logfile = My.Settings.ErrorLog
        loglevel = My.Settings.ErrorLogLevel
        logging = CType([Enum].Parse(GetType(ErrLogLevel), loglevel), ErrLogLevel)

        ' The ThreadAbortException is caused by a poll timeout, so there's
        ' probably no need to record it here at the same DetailLevel as an
        ' error
        If TypeOf ex Is ThreadAbortException Then
            ' override the DetailLevel setting for this exception
            logging = ErrLogLevel.Full
        End If

        ' do we want to report this one?
        If logfile = "" Or logging < DetailLevel Then
            Exit Sub
        End If

        Do While Not IsNothing(ex)
            If PC_Name <> "" And PC_Name <> Environment.MachineName Then
                sb.Append("PCName: " & PC_Name & vbCrLf)
                sb.Append("RemoteFrom: " & Environment.MachineName & vbCrLf)
            Else
                sb.Append("PCName: " & Environment.MachineName & vbCrLf)
                sb.Append("RemoteFrom: " & vbCrLf)
            End If
            sb.Append("UserName: " & Environment.UserName.ToLower & vbCrLf)
            sb.Append("Date: " & Now() & vbCrLf)
            ' BTW: Application.ProductVersion doesn't work unless the program is
            ' started from a form!
            asm = System.Reflection.Assembly.GetExecutingAssembly()
            sb.Append("Version: " & asm.GetName.Name & " v" & asm.GetName.Version.ToString & " (" & asm.ImageRuntimeVersion & ")" & vbCrLf)
            sb.Append("Table: " & TableName & vbCrLf)
            sb.Append("DetailLevel: " & DetailLevel.ToString & vbCrLf)
            sb.Append("Exception: " & ex.GetType.ToString & vbCrLf)
            sb.Append("Error: " & ex.Message.TrimEnd(vbCrLf.ToCharArray) & vbCrLf)
            sb.Append("Location: " & ex.StackTrace & vbCrLf)
            ' repeat for all nested inner exceptions
            ex = ex.InnerException
        Loop

        Try
            Dim fs As FileStream = New FileStream(logfile, FileMode.Append)
            Dim sw As StreamWriter = New StreamWriter(fs)
            sw.WriteLine(sb.ToString)
            sw.WriteLine("")
            sw.Close()
            fs.Close()
        Catch e As Exception
            ' If you can't record the error to the errorlog, then display it 
            ' on the screen. 
            ' Note: Normally you wouldn't have any user interface inside a
            ' "worker class", but this is an exception to the rule.
            asm = System.Reflection.Assembly.GetExecutingAssembly()
            If asm.EntryPoint.DeclaringType.BaseType Is GetType(System.Object) Then
                Console.WriteLine("Can't record the error message" & vbCr & e.GetType.ToString & vbCr & e.Message & vbCr & vbCr & sb.ToString)
                Beep()
                System.Threading.Thread.Sleep(5000)
            Else
                MsgBox("Can't record the error message" & vbCr & e.GetType.ToString & vbCr & e.Message & vbCr & vbCr & sb.ToString, MsgBoxStyle.Exclamation, "Unreportable Error")
            End If
        End Try
    End Sub

    '
    ' Used during debugging... writes a message to the error log
    '
    Public Shared Sub ErrorLog(ByVal Message As String)
        Try
            Dim fs As FileStream = New FileStream(My.Settings.ErrorLog, FileMode.Append)
            Dim sw As StreamWriter = New StreamWriter(fs)
            sw.WriteLine(";" & Message)
            sw.WriteLine("")
            sw.Close()
            fs.Close()
        Catch ex As Exception
        End Try
    End Sub

    '
    ' Do a physical record sort on the DataTable
    '
    Public Shared Sub DataTableSort(ByVal dt As DataTable, ByVal colname As String)
        Dim dt_temp As DataTable
        Dim dr As DataRow
        Dim drs As DataRow()

        If dt.Rows.Count > 1 Then
            ' make a copy, clear the original
            dt_temp = dt.Copy
            dt.Clear()

            ' sort and import the data back
            drs = dt_temp.Select(Nothing, colname & " ASC")
            For Each dr In drs
                dt.ImportRow(dr)
            Next
        End If
    End Sub

    '
    ' Get the file version information.
    '
    Public Shared Function GetVersion(ByVal file As String) As String
        Dim fvi As FileVersionInfo
        Dim ans As String

        ans = ""
        If System.IO.File.Exists(file) Then
            fvi = FileVersionInfo.GetVersionInfo(file)
            If fvi.FileVersion <> "" Then
                ans = fvi.FileVersion.Replace(",", ".")
            Else
                ans = fvi.FileMajorPart & "." & fvi.FileMinorPart & "." & fvi.FileBuildPart & "." & fvi.FilePrivatePart
            End If
        End If

        Return ans
    End Function

    '
    ' Home-made version of the CPU detection routine (used in GetCPU)
    '
    Public Shared Function GetCPUType(ByVal vendor As String, ByVal s As String) As String
        Dim family As Integer
        Dim model As Integer
        Dim ans As String

        family = CInt("&h" & s.Substring(13, 1))
        model = CInt("&h" & s.Substring(14, 1))

        ans = ""
        Select Case vendor
            Case "GenuineIntel"
                Select Case family
                    Case 4
                        ans = "80486"
                    Case 5
                        If model < 4 Then
                            ans = "Pentium"
                        Else
                            ans = "Pentium MMX"
                        End If
                    Case 6
                        Select Case model
                            Case 1
                                ans = "Pentium Pro"
                            Case 3, 5
                                ans = "Pentium II"   ' or Celeron
                            Case 6
                                ans = "Celeron"
                            Case 7, 8
                                ans = "Pentium III"
                            Case 9, 13
                                ans = "Pentium M"
                            Case 10
                                ans = "Pentium III Xeon"
                            Case 11
                                ans = "Pentium III M"
                            Case 14
                                ans = "Core"
                            Case 15
                                ans = "Core 2"
                            Case Else
                                ans = "Intel Family 6, model " & model
                        End Select
                    Case 15
                        ans = "Pentium 4"
                    Case Else
                        ans = "Intel Family " & family & ", model " & model
                End Select
            Case "AuthenticAMD"
                Select Case family
                    Case 4
                        ans = "Am486"
                    Case 5
                        Select Case model
                            Case 0 To 3
                                ans = "K5"
                            Case 6, 7
                                ans = "K6"
                            Case 8
                                ans = "K6-2"
                            Case 9
                                ans = "K6-III"
                            Case Else
                                ans = "AMD Family 5, model " & model
                        End Select
                    Case 6
                        Select Case model
                            Case 1, 2, 4, 6
                                ans = "Athlon"
                            Case 3, 7
                                ans = "Duron"
                            Case 8, 10
                                ans = "Athlon XP"
                            Case Else
                                ans = "AMD Family 6, model " & model
                        End Select
                    Case 15
                        Select Case model
                            Case 3, 11
                                ans = "Althon 64 x2"
                            Case 4
                                ans = "Althon 64"
                            Case 5
                                ans = "Operton"
                            Case 7
                                ans = "Althon 64 FX"
                            Case Else
                                ans = "AMD Family 15, model " & model
                        End Select
                    Case Else
                        ans = "AMD Family " & family & ", model " & model
                End Select
            Case "CyrixInstead"
                Select Case family
                    Case 4
                        ans = "MediaGX"
                    Case 5
                        ans = "6x86"
                    Case 6
                        ans = "6x86MX/MII"
                    Case Else
                        ans = "Cyrix Family " & family & ", model " & model
                End Select
            Case "CentaurHauls"  ' IDT
                Select Case model
                    Case 4
                        ans = "WinChip"
                    Case 8
                        ans = "WinChip 2"
                    Case 9
                        ans = "WinChip 3"
                    Case 10
                        ans = "Via C7"
                    Case Else
                        ans = "IDT Family " & family & ", model " & model
                End Select
            Case "RiseRiseRise"  ' Rise (never heard of 'em)
                If model < 3 Then
                    ans = "mP6"
                Else
                    ans = "mP6-II"
                End If
            Case "GenuineTMx86"
                Select Case family
                    Case 5
                        ans = "Transmeta TM5x00"
                    Case 15
                        ans = "Transmeta TM8x00"
                    Case Else
                        ans = "Transmeta Family " & family & ", model " & model
                End Select
            Case Else
                ans = vendor & " " & family & ", model " & model
        End Select

        Return ans
    End Function

    '
    ' A simple method of rounding off the CPU as returned by WMI.
    '
    Public Shared Function RoundCPUSpeed(ByVal raw As Integer, ByVal divisor As Integer) As Integer
        Dim temp, div As Double
        Dim ans As Integer

        If raw = 0 Then
            Return 0
        End If

        ' Use the "external speed" to determine the divisor for the
        ' CPU multiplier
        Select Case divisor
            Case 100
                div = 100.0
            Case 133
                div = 133.3333
            Case 166
                div = 166.6666
            Case 200
                div = 200.0
            Case 400    ' quad-pumped
                div = 100.0
            Case 532, 533
                div = 133.3333
            Case 800
                div = 200.0
            Case Else
                div = 33.3333
        End Select

        temp = Math.Round(raw / div)
        ans = CInt(Math.Round(temp * div))

        Return ans
    End Function

    '
    ' Get and decode the Extended Display Identification Data (EDID) block 
    ' from the registry to get the monitor size and perhaps a better name
    '
    Public Shared Sub Monitor_EDID(ByVal reg As RegistryKey, ByVal KeyName As String, ByVal dr As SOSOSDataSet.MonitorRow)
        Dim Monitor As String
        Dim key As RegistryKey
        Dim EDID() As Byte
        Dim i, j As Integer
        Dim blocks As Integer() = {57, 75, 93, 111}
        Dim h, v, d As Double
        Dim MName, AName As String

        ' Get the EDID data from the registry
        key = reg.OpenSubKey("SYSTEM\CurrentControlSet\Enum\" & KeyName & "\Device Parameters", False)
        If Not IsNothing(key) Then

            ' let's get the EDID value
            EDID = CType(key.GetValue("EDID"), Byte())
            If IsNothing(EDID) Then
                key.Close()
                Exit Sub
            End If

            ' bit of sanity checking
            If EDID.Length <> 256 Then
                key.Close()
                Exit Sub
            End If

            ' we check the first 25 bytes to see if we've got a valid EDID
            j = 0
            For i = 0 To 24
                j += EDID(i)
            Next
            If j = 0 Then
                key.Close()
                Exit Sub
            End If

            MName = ""
            AName = ""
            For Each i In blocks
                ' find the "Monitor Name" block
                If EDID(i) = &HFC Then
                    For j = i + 2 To i + 14
                        If EDID(j) = &HA Or EDID(j) = 0 Then
                            Exit For
                        End If
                        MName = MName & Chr(EDID(j))
                    Next
                End If
                ' find "ASCII String" block
                If EDID(i) = &HFE Then
                    For j = i + 2 To i + 14
                        If EDID(j) = &HA Or EDID(j) = 0 Then
                            Exit For
                        End If
                        AName = AName & Chr(EDID(j))
                    Next
                End If
            Next

            ' Find Monitor size (use detailed dimensions if available)
            If EDID(54) <> 0 Then
                h = ((EDID(68) \ 16) * 256 + EDID(66)) / 25.4
                v = ((EDID(68) And 15) * 256 + EDID(67)) / 25.4
            Else
                h = (EDID(21) * 10) / 25.4
                v = (EDID(22) * 10) / 25.4
            End If
            d = Math.Sqrt(h * h + v * v)
            d = Math.Round(d, 1)

            ' build the strings
            If AName = "" And MName = "" Then
                ' Use the device ID... if you've got nothing else
                Monitor = Split(KeyName, "\")(1)
            Else
                Monitor = AName & " " & MName
            End If

            ' Replace the name in dr.Monitor only if needed
            If dr.IsMonitorNull OrElse (dr.Monitor = "Default Monitor" Or dr.Monitor = "Plug and Play Monitor" Or dr.Monitor.StartsWith("ATI ")) Then
                dr.Monitor = Monitor.Trim
            End If
            dr.Monitor_Size = d

            key.Close()
        End If
    End Sub

    '
    ' Format the IP address in a manner that supports sorting
    '
    Public Shared Function Format_IP(ByVal ip As String) As String
        Dim temp() As String
        Dim ans As New StringBuilder
        Dim i As Integer

        If Not IsNothing(ip) AndAlso ip <> "" Then
            ' start with the unformated string
            ans.Append(ip)

            ' for IPv4
            temp = Split(ip, ".")
            If UBound(temp) = 3 Then
                ans.Length = 0
                For i = 0 To 3
                    ans.AppendFormat("{0:000}", CInt(temp(i)))
                    If i <> 3 Then
                        ans.Append(".")
                    End If
                Next
            End If

            ' try this again for IPv6
            ' WMI uses the "zero compressed" notation, which we expand
            temp = Split(ip, ":")
            If UBound(temp) = 5 Then
                ans.Length = 0
                For i = 0 To 5
                    ans.Append(temp(i).PadLeft(4, "0"c))
                    If i <> 5 Then
                        ans.Append(":")
                    End If
                Next
            End If
        End If

        Return ans.ToString
    End Function

    '
    ' This is a recursive routine to search the registry for QFEs
    '
    Public Shared Sub GetQFE_2k(ByVal ds As SOSOSDataSet, ByVal reg As RegistryKey, ByVal KeyName As String, ByVal RegOptions As RegWow64Options)
        Static TopLevel As String
        Static level As Integer = 0
        Dim i, j As Integer
        Dim SubName, temp As String
        Dim key As RegistryKey
        Dim culture As New System.Globalization.CultureInfo("en-US", True)
        Dim dr As SOSOSDataSet.QFERow

        key = reg.OpenSubKey(KeyName, False, RegOptions)
        If IsNothing(key) Then
            Exit Sub
        End If

        If level = 1 Then
            TopLevel = KeyName.Substring(InStrRev(KeyName, "\"))
        End If
        ' search the values
        For Each SubName In key.GetValueNames
            ' If there is a value called "Description"... then we're at the
            ' right place.
            If SubName = "Description" Then
                dr = ds.QFE.NewQFERow
                dr.ID_QFE = ds.SOS(0).ID
                ' get the key name (sometimes previous key name)
                i = InStrRev(KeyName, "\")
                temp = KeyName.Substring(i)
                If temp = "Filelist" Then
                    j = InStrRev(KeyName, "\", i - 1)
                    dr.QFE = Left(Mid(KeyName, j + 1, i - j - 1), ds.QFE.QFEColumn.MaxLength)
                Else
                    dr.QFE = Left(temp, ds.QFE.QFEColumn.MaxLength)
                End If
                dr.QFE_Category = Left(TopLevel, ds.QFE.QFE_CategoryColumn.MaxLength)
                dr.QFE_Description = Left(key.GetValue(SubName).ToString, ds.QFE.QFE_DescriptionColumn.MaxLength)

                If Not IsNothing(key.GetValue("BuildDate")) AndAlso IsDate(key.GetValue("BuildDate")) Then
                    dr.QFE_InstallDate = [Date].Parse(key.GetValue("BuildDate").ToString, culture)
                End If
                If Not IsNothing(key.GetValue("InstalledDate")) AndAlso IsDate(key.GetValue("InstalledDate")) Then
                    dr.QFE_InstallDate = [Date].Parse(key.GetValue("InstalledDate").ToString, culture)
                End If

                ' ignore duplicates
                If IsNothing(ds.QFE.FindByID_QFEQFE(dr.ID_QFE, dr.QFE)) Then
                    ds.QFE.AddQFERow(dr)
                End If
            End If
        Next

        ' descend the tree (recursive subroutine)
        For Each SubName In key.GetSubKeyNames
            level = level + 1
            GetQFE_2k(ds, reg, KeyName & "\" & SubName, RegOptions)
            level = level - 1
        Next
        key.Close()
    End Sub

    '
    ' Search the Win9x registry for QFE's
    ' This is a recursive routine to search the registry
    '
    Public Shared Sub GetQFE_9x(ByVal ds As SOSOSDataSet, ByVal reg As RegistryKey, ByVal KeyName As String)
        Static TopLevel As String
        Static level As Integer = 0
        Dim SubName As String
        Dim key As RegistryKey
        Dim dr As SOSOSDataSet.QFERow

        key = reg.OpenSubKey(KeyName, False)
        If IsNothing(key) Then
            Exit Sub
        End If

        ' snag the keyname for use as the category
        If level = 1 Then
            TopLevel = KeyName.Substring(InStrRev(KeyName, "\"))
        End If
        ' does this key have any values?
        If key.ValueCount > 0 Then
            dr = ds.QFE.NewQFERow
            dr.ID_QFE = ds.SOS(0).ID
            dr.QFE = Left(KeyName.Substring(InStrRev(KeyName, "\")), ds.QFE.QFEColumn.MaxLength)
            dr.QFE_Description = Left(key.GetValue("", "unknown").ToString, ds.QFE.QFE_DescriptionColumn.MaxLength)
            dr.QFE_Category = Left(TopLevel, ds.QFE.QFE_CategoryColumn.MaxLength)

            ' ignore duplicates
            If IsNothing(ds.QFE.FindByID_QFEQFE(dr.ID_QFE, dr.QFE)) Then
                ds.QFE.AddQFERow(dr)
            End If
        End If

        ' descend the tree (recursive subroutine)
        For Each SubName In key.GetSubKeyNames
            level = level + 1
            GetQFE_9x(ds, reg, KeyName & "\" & SubName)
            level = level - 1
        Next
        key.Close()
    End Sub

    '
    ' Search the list of Hot Fixes from WinNT's registry
    '
    Public Shared Sub GetQFE_NT(ByVal ds As SOSOSDataSet, ByVal reg As RegistryKey, ByVal KeyName As String)
        Dim Subname, temp As String
        Dim key, subkey As RegistryKey
        Dim dr As SOSOSDataSet.QFERow

        key = reg.OpenSubKey(KeyName, False)
        If IsNothing(key) Then
            Exit Sub
        End If

        For Each Subname In key.GetSubKeyNames
            subkey = key.OpenSubKey(Subname, False)
            If Not IsNothing(subkey) Then
                temp = subkey.GetValue("Comments", "").ToString
                If temp = "" Then
                    temp = Subname
                End If
                dr = ds.QFE.NewQFERow
                dr.ID_QFE = ds.SOS(0).ID
                dr.QFE = Left(Subname, ds.QFE.QFEColumn.MaxLength)
                dr.QFE_Description = Left(temp, ds.QFE.QFE_DescriptionColumn.MaxLength)
                ' there is no category, so we just make one up
                dr.QFE_Category = "HotFix"

                ' ignore duplicates
                If IsNothing(ds.QFE.FindByID_QFEQFE(dr.ID_QFE, dr.QFE)) Then
                    ds.QFE.AddQFERow(dr)
                End If
                subkey.Close()
            End If
        Next
        key.Close()
    End Sub

    '
    ' Get the patches associated with Office (and any other package installed
    ' via the Windows Installer)
    '
    Public Shared Sub GetQFE_Office(ByVal ds As SOSOSDataSet, ByVal reg As RegistryKey, ByVal KeyName As String, ByVal RegOptions As RegWow64Options)
        Dim SubName, ProdName, PatchName, temp, date_string, KB_Name As String
        Dim key, prodkey, patchkey, subkey As RegistryKey
        Dim culture As New System.Globalization.CultureInfo("en-US", True)
        Dim dr As SOSOSDataSet.QFERow

        key = reg.OpenSubKey(KeyName, False, RegOptions)
        If IsNothing(key) Then
            Exit Sub
        End If

        For Each SubName In key.GetSubKeyNames
            ' get the product name
            ProdName = SubName
            prodkey = key.OpenSubKey(SubName, False, RegOptions)
            If Not IsNothing(prodkey) Then
                subkey = prodkey.OpenSubKey("InstallProperties", False, RegOptions)
                If Not IsNothing(subkey) Then
                    ProdName = subkey.GetValue("DisplayName", "").ToString
                    subkey.Close()
                End If
            End If
            ' get the list of patches
            patchkey = prodkey.OpenSubKey("Patches", False, RegOptions)
            If Not IsNothing(patchkey) Then
                For Each PatchName In patchkey.GetSubKeyNames
                    subkey = patchkey.OpenSubKey(PatchName, False, RegOptions)
                    If Not IsNothing(subkey) Then
                        ' get the values from here
                        temp = subkey.GetValue("DisplayName", "").ToString
                        If temp = "" Then
                            temp = SubName
                        End If

                        ' get the KB number from the DisplayName field 
                        KB_Name = ""
                        If temp Like "*(KB######)*" Then
                            KB_Name = temp.Substring(temp.IndexOf("(KB") + 1, 8)
                        End If
                        If temp Like "*(Q######)*" Then
                            KB_Name = temp.Substring(temp.IndexOf("(Q") + 1, 7)
                        End If

                        ' We ignore other entries that are not KB or Q
                        If KB_Name <> "" Then
                            dr = ds.QFE.NewQFERow
                            dr.ID_QFE = ds.SOS(0).ID
                            dr.QFE = Left(KB_Name, ds.QFE.QFEColumn.MaxLength)
                            dr.QFE_Description = Left(temp, ds.QFE.QFE_DescriptionColumn.MaxLength)

                            ' get the install date
                            date_string = subkey.GetValue("Installed", "").ToString
                            If date_string.Length = 8 Then
                                date_string = date_string.Substring(4, 2) & "/" & date_string.Substring(6, 2) & "/" & date_string.Substring(0, 4)
                                If IsDate(date_string) Then
                                    dr.QFE_InstallDate = [Date].Parse(date_string, culture)
                                End If
                            End If
                            dr.QFE_Category = Left(ProdName, ds.QFE.QFE_CategoryColumn.MaxLength)

                            ' ignore duplicates
                            If IsNothing(ds.QFE.FindByID_QFEQFE(dr.ID_QFE, dr.QFE)) Then
                                ds.QFE.AddQFERow(dr)
                            End If
                        End If
                        subkey.Close()
                    End If
                Next
                patchkey.Close()
            End If
            prodkey.Close()
        Next
        key.Close()
    End Sub

    '
    ' Get the "Update Packages" for Windows Vista.  We use the file-based logs
    ' instead of reading the ESE database (so that down-level clients can get
    ' the data remotely)
    '
    Public Shared Sub GetQFE_Vista(ByVal ds As SOSOSDataSet, ByVal PackageDir As String)
        Dim mum_file, QFE, QFE_Desc, QFE_Cat As String
        Dim xml_doc As Xml.XmlDocument
        Dim xml_nsm As XmlNamespaceManager
        Dim xml_node As Xml.XmlNode
        Dim dr As SOSOSDataSet.QFERow

        For Each mum_file In Directory.GetFiles(PackageDir, "Package*.mum")
            xml_doc = New Xml.XmlDocument
            xml_doc.Load(mum_file)
            xml_nsm = New XmlNamespaceManager(xml_doc.NameTable)
            xml_nsm.AddNamespace("up", "urn:schemas-microsoft-com:asm.v3")

            QFE = ""
            QFE_Desc = ""
            QFE_Cat = ""

            ' get the QFE name
            xml_node = xml_doc.SelectSingleNode("//up:package", xml_nsm)
            If Not IsNothing(xml_node) Then
                If Not IsNothing(xml_node.Attributes("identifier")) Then
                    QFE = xml_node.Attributes("identifier").Value
                End If
            End If

            ' Description/Category for component updates
            xml_node = xml_doc.SelectSingleNode("//up:updateComponent/up:assemblyIdentity", xml_nsm)
            If Not IsNothing(xml_node) Then
                If Not IsNothing(xml_node.Attributes("name")) Then
                    QFE_Cat = "Component Update"
                    QFE_Desc = xml_node.Attributes("name").Value
                End If
            End If

            ' Description/Category driver updates
            xml_node = xml_doc.SelectSingleNode("//up:updateDriver/up:assemblyIdentity", xml_nsm)
            If Not IsNothing(xml_node) Then
                If Not IsNothing(xml_node.Attributes("name")) Then
                    QFE_Cat = "Driver Update"
                    QFE_Desc = xml_node.Attributes("name").Value
                End If
            End If

            If QFE <> "" And QFE_Desc <> "" Then
                dr = ds.QFE.NewQFERow
                dr.ID_QFE = ds.SOS(0).ID
                dr.QFE = QFE
                dr.QFE_Category = QFE_Cat
                dr.QFE_Description = QFE_Desc
                dr.QFE_InstallDate = File.GetCreationTime(mum_file)
                ' ignore duplicates
                If IsNothing(ds.QFE.FindByID_QFEQFE(dr.ID_QFE, dr.QFE)) Then
                    ds.QFE.AddQFERow(dr)
                End If
            End If

        Next
    End Sub

    '
    ' Decode the permissions mask (used in GetPermissions)
    '
    Public Shared Function MaskToString(ByVal mask As Integer) As String
        Select Case mask
            Case AccessType.FILE_ALL_ACCESS
                Return ("Full Control")
            Case AccessType.FILE_ALL_ACCESS And Not (AccessType.WRITE_DAC Or AccessType.WRITE_OWNER Or AccessType.FILE_DELETE_CHILD)
                Return ("Change & Read")
            Case AccessType.FILE_GENERIC_READ Or AccessType.FILE_GENERIC_EXECUTE
                Return ("Read")
        End Select

        Return ("Error")
    End Function

    '
    ' Set the privileges that are not enabled by default.
    ' 
    Public Shared Function SetPrivileges() As Boolean
        Dim hProc, hToken As IntPtr
        Dim luid_Restore, luid_Backup, luid_Security As Long
        Dim Len As Integer
        Dim tp As New TOKEN_PRIVILEGES

        ' Get the current process's token
        hProc = Process.GetCurrentProcess().Handle
        hToken = IntPtr.Zero
        If Not OpenProcessToken(hProc, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, hToken) Then
            Return False
        End If

        ' Get the LUIDs for the Backup, Restore, and Security privileges
        luid_Restore = 0
        If Not LookupPrivilegeValue(Nothing, SE_RESTORE_NAME, luid_Restore) Then
            Return False
        End If
        luid_Backup = 0
        If Not LookupPrivilegeValue(Nothing, SE_BACKUP_NAME, luid_Backup) Then
            Return False
        End If
        luid_Security = 0
        If Not LookupPrivilegeValue(Nothing, SE_SECURITY_NAME, luid_Security) Then
            Return False
        End If

        tp.PrivilegeCount = 3
        tp.Privilege1.Luid = luid_Restore
        tp.Privilege1.Attributes = SE_PRIVILEGE_ENABLED
        tp.Privilege2.Luid = luid_Backup
        tp.Privilege2.Attributes = SE_PRIVILEGE_ENABLED
        tp.Privilege3.Luid = luid_Security
        tp.Privilege3.Attributes = SE_PRIVILEGE_ENABLED

        ' Enable the privileges
        Len = 0
        If Not AdjustTokenPrivileges(hToken, False, tp, 0, IntPtr.Zero, Len) Then
            Return False
        End If

        Return True
    End Function

    '
    ' Mount the user's registry hive (used in GetProfiles)
    '
    Public Shared Sub MountHive(ByVal RemotePC As String, ByVal keyname As String, ByVal HiveFile As String)
        Dim hReg As RegistryKey

        ' We start with connecting to HKEY_USERS on the remote PC using
        ' the API calls
        If RemotePC = "" Then
            hReg = Registry.Users
        Else
            hReg = RegistryKey.OpenRemoteBaseKey(RegistryHive.Users, RemotePC)
        End If

        ' Load the registry hive.  Since we're loading these hives
        ' remotely, the path is relative to that PC.
        RegistryKey.LoadKey(hReg, keyname, HiveFile)
        hReg.Close()
    End Sub

    '
    ' Unmount the user's registry hive (used in Snoop's destructor)
    '
    Public Shared Sub UnMountHive(ByVal RemotePC As String, ByVal keyname As String)
        Dim hReg As RegistryKey

        If RemotePC = "" Then
            hReg = Registry.Users
        Else
            hReg = RegistryKey.OpenRemoteBaseKey(RegistryHive.Users, RemotePC)
        End If

        RegistryKey.UnLoadKey(hReg, keyname)
        hReg.Close()
    End Sub

    '
    ' Take a "raw" SID (as a byte array) and determine the User ID (used in
    ' GetProfiles) (overloaded)
    '
    Public Shared Function SidToName(ByVal RemotePC As String, ByVal RawSid As Byte()) As String
        Dim Sid As IntPtr
        Dim gch As GCHandle
        Dim ans As String

        ' get a safe pointer to the SID array of bytes
        gch = GCHandle.Alloc(RawSid, GCHandleType.Pinned)
        Sid = Marshal.UnsafeAddrOfPinnedArrayElement(RawSid, 0)
        ans = SidToName(RemotePC, Sid)
        gch.Free()

        Return ans
    End Function

    '
    ' Take a String version of a SID and generate a User ID (used in
    ' GetProfiles) (overloaded)
    '
    Public Shared Function SidToName(ByVal RemotePC As String, ByVal sid_string As String) As String
        Dim sid As IntPtr

        sid = StringToSID(sid_string)
        If IsNothing(sid) Then
            Return sid_string
        End If

        Return SidToName(RemotePC, sid)
    End Function

    '
    ' Take an IntPtr SID and generate the User ID (overloaded)
    '
    Private Shared Function SidToName(ByVal RemotePC As String, ByVal sid As IntPtr) As String
        Dim UserName, name, domain_name As String
        Dim name_len, domain_len, peUse As Integer

        name_len = NAME_SIZE
        domain_len = NAME_SIZE
        name = Space(name_len)
        domain_name = Space(domain_len)

        ' look up the Account associated with that SID
        If LookupAccountSid(RemotePC, sid, name, name_len, domain_name, domain_len, peUse) = False Then
            ' if the lookup fails, return the SID as as string
            Return SIDtoString(sid)
        End If

        ' put the name parts together
        If domain_len > 0 Then
            UserName = Left(domain_name, domain_len) & "\" & Left(name, name_len)
        Else
            If RemotePC = "" Then
                RemotePC = Environment.MachineName
            End If
            UserName = RemotePC & "\" & Left(name, name_len)
        End If

        Return UserName
    End Function

    '
    ' Convert a SID into the string version of the SID
    '
    Private Shared Function SIDtoString(ByVal sid As IntPtr) As String
        Dim ans As String
        Dim pStr As IntPtr

        If Environment.OSVersion.Version.Major = 4 Then
            ' WinNT doesn't have the ConvertSidToString API
            ans = ConvertSidToStringSidNT(sid)
        Else
            ConvertSidToStringSid(sid, pStr)
            ans = Marshal.PtrToStringAuto(pStr)
            Marshal.FreeHGlobal(pStr)
        End If

        Return ans
    End Function

    '
    ' Convert a "raw" SID (as a byte array) into a string (overloaded)
    '
    Public Shared Function SIDtoString(ByVal sidbyte As Byte()) As String
        Dim sid As IntPtr
        Dim gch As GCHandle
        Dim ans As String

        ' get a safe pointer
        gch = GCHandle.Alloc(sidbyte, GCHandleType.Pinned)
        sid = Marshal.UnsafeAddrOfPinnedArrayElement(sidbyte, 0)
        ans = SIDtoString(sid)
        gch.Free()

        Return ans
    End Function

    '
    ' Convert a string representation of a SID into a real SID
    '
    Public Shared Function StringToSID(ByVal buf As String) As IntPtr
        Dim sid As IntPtr

        If Environment.OSVersion.Version.Major = 4 Then
            ' WinNT doesn't have the ConvertStringSidToSid API
            sid = ConvertStringSidToSidNT(buf)
        Else
            If ConvertStringSidToSid(buf, sid) = False Then
                Return Nothing
            End If
        End If

        Return sid
    End Function

    '
    ' a WinNT version of the ConvertSidToStringSid function
    '
    Private Shared Function ConvertSidToStringSidNT(ByVal Sid As IntPtr) As String
        Dim sb As New StringBuilder
        Dim psia As SID_IDENTIFIER_AUTHORITY
        Dim i, num, temp As Integer
        Dim top As Long
        Dim iptr As IntPtr

        If Not IsValidSid(Sid) Then
            Return ""
        End If

        sb.Append("S-1-")

        ' Get the top level authority
        iptr = GetSidIdentifierAuthority(Sid)
        psia = CType(Marshal.PtrToStructure(iptr, GetType(SID_IDENTIFIER_AUTHORITY)), SID_IDENTIFIER_AUTHORITY)

        ' How many sub authorities?
        iptr = GetSidSubAuthorityCount(Sid)
        num = Marshal.ReadInt16(iptr)

        ' Use the hex version of the top authority?
        If psia.Value(0) <> 0 And psia.Value(1) <> 0 Then
            sb.AppendFormat("0x{0:x2}" & psia.Value(0))
            sb.AppendFormat("x{0:x2}" & psia.Value(1))
            sb.AppendFormat("x{0:x2}" & psia.Value(2))
            sb.AppendFormat("x{0:x2}" & psia.Value(3))
            sb.AppendFormat("x{0:x2}" & psia.Value(4))
            sb.AppendFormat("x{0:x2}" & psia.Value(5))
        Else
            top = psia.Value(5)
            top += psia.Value(4) * 256
            top += psia.Value(3) * 256 * 256
            top += psia.Value(2) * 256 * 256 * 256
            sb.Append(top.ToString)
        End If

        For i = 0 To num - 1
            iptr = GetSidSubAuthority(Sid, i)
            temp = Marshal.ReadInt32(iptr)
            sb.Append("-" & temp.ToString)
        Next

        Return sb.ToString
    End Function

    '
    ' A WinNT version of the ConvertStringSidToSid API
    '
    Private Shared Function ConvertStringSidToSidNT(ByVal buf As String) As IntPtr
        Dim pSID As IntPtr
        Dim parts() As String
        Dim i, num As Integer
        Dim SubA(7) As Integer
        Dim b() As Byte
        Dim sia As New SID_IDENTIFIER_AUTHORITY

        parts = buf.Split("-"c)
        If parts.Length < 3 Then
            Return Nothing
        End If

        ' a bit of sanity checking
        If parts(0) <> "S" Or parts(1) <> "1" Then
            Return Nothing
        End If

        ' is this a hex version of the top sid authority?
        ReDim sia.Value(5)
        If parts(2).StartsWith("0x") And parts(2).Length = 14 Then
            ' BTW: Has anybody actually ever seen a SID with a hex-based
            ' Identifier Authority?
            For i = 0 To 5
                sia.Value(i) = CByte("&h" & parts(2).Substring((i * 2) + 2, 2))
            Next
        Else
            ' why BigEndian?
            b = BitConverter.GetBytes(Convert.ToUInt32(parts(2)))
            For i = 2 To 5
                sia.Value(i) = b(5 - i)
            Next
        End If

        num = parts.Length - 3
        For i = 0 To num - 1
            SubA(i) = Convert.ToInt32(parts(i + 3))
        Next

        If AllocateAndInitializeSid(sia, CByte(num), SubA(0), SubA(1), SubA(2), SubA(3), SubA(4), SubA(5), SubA(6), SubA(7), pSID) = False Then
            Return Nothing
        End If

        Return pSID
    End Function

    '
    ' Convert a byte array into a hex string
    '
    Public Shared Function ByteArrayToString(ByVal b As Byte()) As String
        Dim sb As New StringBuilder
        Dim i As Integer

        If IsNothing(b) OrElse b.Length = 0 Then
            Return Nothing
        End If

        For i = 0 To b.Length - 1
            sb.AppendFormat("{0:X2}", b(i))
        Next

        Return sb.ToString
    End Function
End Class
